<template>
  <div id="content-wrap">
    <div class="actions">
      <div id="buttons">
        <button id="new"
        v-on:click="$emit('change-component', 'City'); $emit('object',0)">
          Create New
        </button>
      </div>
    </div>
    <div class="table-wrap">
      <table class="tab">
        <thead>
          <tr>
            <th>City</th>
            <th>Region</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="city in cities" v-bind:key="city.id" v-bind:item="city">
            <td>{{city.city}}</td>
            <td>{{city.region}}</td>
            <td>
              <button v-on:click="modify(city.id)">Modify</button>
              <button v-on:click="deleteObj(city)">Delete</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Cities',
  data() {
    return {
      cities: [],
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      axios.get('http://localhost:4000/api/cities').then(
        (result) => {
          this.cities = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    modify(city) {
      this.$emit('change-component', 'City');
      this.$emit('object', city);
      console.log(city);
    },
    deleteObj(city) {
      const url = `http://localhost:4000/api/cities/${city.id}`;
      axios.delete(url).then(
        (result) => {
          if (result) { this.get(); }
        },
      ).catch((error) => {
        console.log(error);
      });
    },
  },
};
</script>

<style scoped>
@import "../CSS/Managment.css";
</style>
